import Qt 4.7

Item {
    id: container

    width: 140
    height: 140

    signal clicked
    signal pressedRepeat
    property string buttonText
    property string imagePath

    Image {
        id: buttonImage
        anchors.verticalCenter: container.verticalCenter
        anchors.horizontalCenter: container.horizontalCenter
        width: container.width
        height: container.height
        source: imagePath
        scale: mouseRegion.pressed ? 0.8 : 1.0
        smooth: true
    }
    Timer {
        id: pressRepeatTimer
        interval: 300; running: false; repeat: true
        onTriggered: container.pressedRepeat()
    }

    MouseArea {
        id: mouseRegion
        anchors.fill: container
        onClicked: container.clicked()
        onPressed: {
            // Start timer and send the repeat events from there
            // This assumes clicked was sent also.
            pressRepeatTimer.start()
        }
        onReleased: {
            // Shutdown timer
            pressRepeatTimer.stop()
        }
    }

    Text {
        id: btext
        anchors.horizontalCenter: container.horizontalCenter
        anchors.verticalCenter: container.verticalCenter
        font.pointSize:  0.8*parent.height
        font.bold:  true
        color:  "white"
        text:  buttonText
    }
}
