function mapToDial(posx, posy) {
    var magic = 418
    var ehex = 2*(posx - 0.5*magic)/magic;
    var ehey = 2*(posy - 0.5*magic)/magic;
    var dist = Math.sqrt(ehex*ehex + ehey*ehey)
    var alpha
    if (dist > 0.7 && dist < 1.15) {
        alpha = 180/Math.PI*Math.acos(ehex/dist)
        if (ehey < 0)
            alpha = 360 - alpha
        if (alpha < 70)
            alpha = alpha + 360
    }
    else
        alpha = -1
    return alpha
}

function angleToBpm(a) {
    return 30 + 200*(a - 110)/320
}
function bpmToAngle(b) {
    return 110 + 320*(b - 30)/200
}

var manualTapTimes = new Array();
function getAverageTap() {
    var d = new Date();
    var t_ms = d.getTime();

    // if first, just save it
    if (manualTapTimes.length == 0) {
        manualTapTimes.push(t_ms);
        return -1;
    }
    // if previous is too old, discard all data
    if (t_ms - manualTapTimes[manualTapTimes.length-1] > 2000) {
        while (manualTapTimes.length != 0) {
            manualTapTimes.pop()
        }
        return -1;
    }

    // push current to end
    manualTapTimes.push(t_ms);

    // if length > N, shift from beginning (remove oldest time)
    var movingAvgLen = 3;
    if (manualTapTimes.length > movingAvgLen) {
        manualTapTimes.shift();
        // Then calculate the average (only if full array)
        var i = 0;
        var avg = 0;
        for (i = 0; i < manualTapTimes.length-1; i++) {
            avg += manualTapTimes[i+1] - manualTapTimes[i];
        }
        avg = avg/(manualTapTimes.length-1);

        // ms -> bpm
        return 60000/avg;
    }

    return -1
}

